package com.yuandian.dataflow;

 
import java.io.File;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.SpringBootConfiguration;
import org.springframework.boot.autoconfigure.SpringBootApplication;

import com.alipay.sofa.jraft.JRaftUtils;
import com.alipay.sofa.jraft.Node;
import com.alipay.sofa.jraft.RaftGroupService;
import com.alipay.sofa.jraft.conf.Configuration;
import com.alipay.sofa.jraft.entity.PeerId;
import com.alipay.sofa.jraft.option.NodeOptions;
import com.yuandian.dataflow.statemachine.RaftClosure;
import com.yuandian.dataflow.statemachine.StateMachine;
import com.yuandian.dataflow.statemachine.StateServer;
import com.yuandian.dataflow.statemachine.rpc.SyncDataProcessor;

import lombok.var;

 


/**
 * Hello world!
 *
 */
@SpringBootApplication
@SpringBootConfiguration
public class Server {
    
    @Autowired
    public static Node node;
    public static RaftClosure done;
    private static StateServer stateServer;
    
    public static Node GetNode()  {
        return node;
    }   

    public static RaftClosure GetDone()  {
        return done;
    }   
 

    
    public static void main(String[] args) {

        String[] peers = new String[]{"localhost:4440","localhost:4441","localhost:4442"};
        String[] sprPeers = new String[]{"3440","3441","3442"};
        var peeridstr = peers[ Integer.parseInt(args[0] )];
        var sprPort = sprPeers[Integer.parseInt(args[0] )];


        Configuration conf = JRaftUtils.getConfiguration("localhost:4440,localhost:4441,localhost:4442");
        stateServer = new StateServer(peeridstr, conf);

        
        System.setProperty("server.port", sprPort);
        var app = SpringApplication.run(Server.class, args);
        app.start();
    }
}
