/**
 * description
 *
 * @author eson
 *2022年7月12日-13:36:24
 */
package com.yuandian.dataflow.statemachine;
 
import java.io.File;

import com.alibaba.nacos.common.remote.client.RpcClient;
import com.alipay.sofa.jraft.JRaftUtils;
import com.alipay.sofa.jraft.Node;
import com.alipay.sofa.jraft.RaftGroupService;
import com.alipay.sofa.jraft.conf.Configuration;
import com.alipay.sofa.jraft.entity.PeerId;
import com.alipay.sofa.jraft.error.RemotingException;
import com.alipay.sofa.jraft.option.CliOptions;
import com.alipay.sofa.jraft.option.NodeOptions;
import com.alipay.sofa.jraft.rpc.InvokeCallback;
import com.alipay.sofa.jraft.rpc.impl.BoltRaftRpcFactory;
import com.alipay.sofa.jraft.util.Endpoint;
import com.yuandian.dataflow.statemachine.RaftClosure;
import com.yuandian.dataflow.statemachine.StateMachine;
import com.yuandian.dataflow.statemachine.rpc.SyncData;
import com.yuandian.dataflow.statemachine.rpc.SyncDataProcessor;

import lombok.var;
import lombok.extern.slf4j.Slf4j;

/**
 * description
 *
 * @author eson
 *2022年7月12日-13:36:24
 */
@Slf4j
@var
public class StateServer {

    public Node node;
    public RaftGroupService cluster;
    public StateMachine fsm;

    private String groupId = "dataflow"; 

    public StateServer(String addr, Configuration conf) {
        String[] peers = new String[]{"localhost:4440","localhost:4441","localhost:4442"};
        String[] sprPeers = new String[]{"3440","3441","3442"};

        // var peeridstr = peers[Integer.parseInt(serverId)];
        // var sprPort = sprPeers[Integer.parseInt(args[0])];

        // String groupId = "jraft";

        // Configuration conf = JRaftUtils.getConfiguration("localhost:4440,localhost:4441,localhost:4442");

        PeerId serverId = JRaftUtils.getPeerId(addr);
        int port = serverId.getPort();

        NodeOptions nodeOptions = new NodeOptions();
        nodeOptions.setElectionTimeoutMs(1000);
        nodeOptions.setSnapshotLogIndexMargin(3600);
        nodeOptions.setInitialConf(conf);

        File RaftDataFile = new File(String.format("./raftdata/%d", port) );
        log.info("{}",RaftDataFile.mkdirs());  

        nodeOptions.setLogUri( String.format("./raftdata/%d/logs", port) );
        nodeOptions.setRaftMetaUri(String.format("./raftdata/%d/rafts", port));
        nodeOptions.setSnapshotUri(String.format("./raftdata/%d/snaps", port));
        fsm = new StateMachine(); // 状态实例初始化
        nodeOptions.setFsm(fsm);

         cluster = new RaftGroupService(groupId, serverId, nodeOptions);
        cluster.getRpcServer().registerProcessor(new SyncDataProcessor());

        
 

        node = cluster.start();
    }
    

    public static void main(String[] args) throws InterruptedException, RemotingException {
        var rpcClient = new BoltRaftRpcFactory().createRpcClient();

    
        rpcClient.init(new CliOptions());
        
        var resp = rpcClient.invokeSync(new Endpoint("localhost",4441), new SyncData(), 5000);
        log.info("{}", resp);

        // done = new RaftClosure();
        // node.shutdown(done);
    }
}
